package com.gct.tools.etlcamelhuge.routeconfig;

import com.alibaba.fastjson.JSONObject;
import com.gct.tools.etlcamelhuge.entity.MQDiagnoseMsg;
import org.apache.camel.Exchange;
import org.apache.camel.Predicate;
import org.apache.camel.Processor;
import org.apache.camel.builder.RouteBuilder;
import org.apache.rocketmq.client.producer.DefaultMQProducer;
//import org.apache.rocketmq.common.message.Message;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.http.HttpEntity;
import org.springframework.http.HttpHeaders;
import org.springframework.http.MediaType;
import org.apache.camel.Message;
import java.math.BigDecimal;
import java.nio.charset.StandardCharsets;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;

/**
 * class name: CamelJDBCConfiguration
 *
 * @author lloyd
 * @version 1.0
 * @since 2021/4/14 下午3:16
 */
@Configuration
public class CamelJDBCConfiguration extends RouteBuilder{

    /***
     * 从天安那边获取功图数据
     */
   @Override
    public void configure() throws Exception {
        SimpleDateFormat formatter = new SimpleDateFormat("yyyy-MM-dd");
        Date date = new Date(System.currentTimeMillis());
        String formatDate = formatter.format(date)+" 00:00:00";
        // 一小时执行一次
       from("timer:mytimer1?period=3600000")
               .routeId("jdbc-gtsj-?")
               .setHeader("dyna_create_time", constant(formatDate))
               .setBody(simple("select well_id,dyna_create_time,check_date,displacement,disp_load from public.pc_fd_pumpjack_dyna_dia_t where dyna_create_time > '${header.dyna_create_time}'::timestamp and dyna_create_time <'${header.dyna_create_time}'::timestamp + '1 day' order by dyna_create_time and well_id ='SQ2306' "))
               .to("jdbc:gtsj")
               .split(body()).process(exchange -> {
           Message in = exchange.getIn();
           HashMap<String, Object> aRow = in.getBody(HashMap.class);
           String prod_date = aRow.get("dyna_create_time").toString().split("\\+")[0];
           aRow.put("dyna_create_time", prod_date);
           if (aRow.get("displacement") != null && !aRow.get("displacement").equals("") && aRow.get("disp_load") != null && !aRow.get("disp_load").equals("")) {
               String[] displacements = aRow.get("displacement").toString().split(";");
               String[] disp_loads = aRow.get("disp_load").toString().split(";");
               String sgt = "";
               for (int i = 0; i < displacements.length; i++) {
                   sgt = sgt + displacements[i] + "," + disp_loads[i] + ",";
               }
               String[] s = sgt.split(",");
               String w = "";
               for (int i = 0; i < s.length; i++) {
                   w += new BigDecimal(Math.round(Double.parseDouble(s[i]) * 100)).stripTrailingZeros().toPlainString() + ",";
               }
               aRow.put("sgt", w);
           }

       })//从这里开始
               .setHeader("well_name", simple("${body[well_id]}"))
               .setHeader("pord_date", simple("${body[dyna_create_time]}"))
               .setHeader("rcv_date", simple("${body[check_date]}"))
               .setHeader("sgt", simple("${body[sgt]}"))
               .setBody(simple("update centralbase.cb_temp_well_mech_runtime  set prod_date = '${body[dyna_create_time]}',sgt = '${body[sgt]}'  where well_id = (select well_id  from centralbase.cb_cd_well_source where well_common_name = '${body[well_id]}')"))
               .to("jdbc:centralbase")
               .setBody(simple("select well_id,org_id from centralbase.cb_cd_well_source where well_common_name = '${in.header.well_name}' "))
               .to("jdbc:centralbase")
               .setHeader("well_id", simple("${body[well_id]}"))
               .setHeader("org_id", simple("${body[org_id]}"))
               .process(exchange -> {

                   JSONObject jo = new JSONObject();
                   jo.put("well_name", "${in.header.well_id}");
                   jo.put("org_id", "${in.header.org_id}");
                   jo.put("prod_date", "${in.header.pord_date}");
                   jo.put("sgt", "${in.header.sgt}");
                   //RocketMQTemplate rocketMQTemplate = new RocketMQTemplate();
                   DefaultMQProducer producer = new DefaultMQProducer("test");
                   producer.setNamesrvAddr("10.72.143.2:9876");
                   // producer.setCreateTopicKey("AUTO_CREATE_TOPIC_KEY");
                   producer.start();
                   org.apache.rocketmq.common.message.Message message = new org.apache.rocketmq.common.message.Message();
                   message.setKeys("XJ_001");
                   message.setBody(jo.toJSONString().getBytes(StandardCharsets.UTF_8));
                   message.setTopic("Diagnose_MsgV1");
                   /* rocketMQTemplate.sendOneWayOrderly("Diagnose_MsgV1",jo,"XJ_001");*/
                   producer.sendOneway(message);
                   System.out.println(" send ");
               }).log("insert!!!").end();

       //从天安那边获取状态日数据

        from("timer:mytimer2?period=3600000")
                .routeId("jdbc-ztr-?")
                .setHeader("acqui_time", constant(formatDate))
                .setBody(simple("select well_id,acqui_time,phase_a_current,phase_b_current,phase_c_current,tubing_pre,casing_pre,phase_a_voltage,phase_b_voltage,phase_c_voltage from public.t_dyna_well_oil where acqui_time > '${header.acqui_time}'::timestamp and acqui_time <'${header.acqui_time}'::timestamp + '1 day'"))
                .to("jdbc:gtsj")
                .split(body()).process(exchange -> {
            Message in = exchange.getIn();
            HashMap<String, Object> aRow = in.getBody(HashMap.class);
            if(aRow.get("phase_a_current").toString() == null || aRow.get("phase_b_current").toString() == null ||aRow.get("phase_c_current").toString() == null ||aRow.get("tubing_pre").toString() == null ||aRow.get("casing_pre").toString() == null ||aRow.get("phase_a_voltage").toString() == null ||aRow.get("phase_b_voltage").toString() == null || aRow.get("phase_c_voltage").toString() == null){
                aRow.put("phase_a_current","0.0");
                aRow.put("phase_b_current","0.0");
                aRow.put("phase_c_current","0.0");
                aRow.put("tubing_pre","0.0");
                aRow.put("casing_pre","0.0");
                aRow.put("phase_a_voltage","0.0");
                aRow.put("phase_b_voltage","0.0");
                aRow.put("phase_c_voltage","0.0");
            }
        })
                .setBody(simple("update centralbase.cb_pc_pro_wellbore_status_daily  set prod_date = '${body[acqui_time]}'::timestamp,elec_pump_current_a = '${body[phase_a_current]}',elec_pump_current_b = '${body[phase_b_current]}',elec_pump_current_c = '${body[phase_c_current]}',tubing_pres = '${body[tubing_pre]}',casing_pres = '${body[casing_pre]}' ,elec_pump_voltage_a = '${body[phase_a_voltage]}',elec_pump_voltage_b = '${body[phase_b_voltage]}',elec_pump_voltage_c = '${body[phase_c_voltage]}' where well_id = (select well_id  from centralbase.cb_cd_well_source where well_common_name = '${body[well_id]}')"))
                .to("jdbc:centralbase")
                .log("insert completed")
                .end();

       from("timer:send?period=30000")
               .routeId("Diagnose_MsgV1")
               //.setBody(simple("select * from "))
               .process(exchange -> {
                   JSONObject jo = new JSONObject();
                   jo.put("well_name", "XJ_001");
                   jo.put("org_id", "14");
                   jo.put("prod_date", "2021-01-25 09:00:00");
                   jo.put("sgt", "0,4176,0,4208,1,4256,3,4304,6,4416,9,4496,12,4576,17,4768,21,4864,25,4912,32,4864,38,4784,43,4704,52,4560,59,4496,66,4480,73,4496,84,4608,92,4688,100,4736,112,4816,121,4816,129,4800,143,4704,152,4640,161,4592,175,4560,185,4560,194,4576,204,4592,218,4640,227,4656,237,4656,251,4640,260,4624,269,4592,283,4512,292,4480,300,4464,313,4432,321,4432,329,4448,337,4448,348,4432,355,4400,362,4368,371,4304,377,4256,383,4208,390,4128,395,4112,399,4096,405,4064,408,4064,411,4047,414,4064,416,4064,418,4047,419,4047,419,4032,419,4015,419,3968,417,3904,416,3856,414,3792,410,3600,407,3536,403,3504,399,3520,393,3584,388,3647,383,3711,374,3824,368,3808,362,3776,352,3679,345,3615,337,3568,326,3504,317,3520,309,3536,301,3584,288,3647,279,3664,270,3664,256,3647,247,3600,237,3568,223,3520,213,3504,204,3504,190,3536,180,3568,171,3600,161,3615,148,3647,139,3647,130,3632,117,3615,108,3615,100,3615,88,3632,80,3664,73,3696,63,3760,56,3792,50,3808,44,3840,35,3856,30,3856,25,3872,19,3904,15,3920,12,3952,7,4015,5,4047,3,4064,1,4096,0,4112,0,4112");
                   //RocketMQTemplate rocketMQTemplate = new RocketMQTemplate();
                   DefaultMQProducer producer = new DefaultMQProducer("test");
                   producer.setNamesrvAddr("10.72.143.2:9876");
                   // producer.setCreateTopicKey("AUTO_CREATE_TOPIC_KEY");
                   producer.start();
                   org.apache.rocketmq.common.message.Message message = new org.apache.rocketmq.common.message.Message();
                   message.setKeys("XJ_001");
                   message.setBody(jo.toJSONString().getBytes(StandardCharsets.UTF_8));
                   message.setTopic("Diagnose_MsgV1");
                   /* rocketMQTemplate.sendOneWayOrderly("Diagnose_MsgV1",jo,"XJ_001");*/
                   producer.sendOneway(message);
                   System.out.println(" send ");
               }).end();
    };


    /*@Bean
    public RouteBuilder routeBuilder() {
        ArrayList<HashMap<String, Object>> hashMaps = new ArrayList<>();
        return new RouteBuilder() {
            @Override
            public void configure() throws Exception {
                from("timer://foo?period=1000")
                        .routeId("jdbc-pg-?")
                        .setHeader("prod_time_ctl", constant("2021-02-27 10:00:00.000000"))
                        //.setBody(constant("select * from centralbase.cb_temp_well_mech_runtime where prod_date= :prod_time_ctl "))
                        .setBody(simple("select * from centralbase.cb_temp_well_mech_runtime where prod_date= :?prod_time_ctl ::timestamp "))
                        .log("select body :${body}")
                        .to("jdbc:centralbase?useHeadersAsParameters=true")
                        .tracing()
                        //via transform
                        .transform()
                        .body(result -> {
                            ArrayList<HashMap<String, Object>> list = hashMaps.getClass().cast(result);
                            log.info("The data count:{}", list.toString());
                            return list;
                        })
                        //split data to one by one
                        .split(body()).process(exchange -> {
                    Message in = exchange.getIn();
                    HashMap<String, Object> aRow = in.getBody(HashMap.class);
                    log.info("The data count2222:{}", aRow.toString());
                })
                        .log("ok?").setHeader("dddd", constant("ssss"))
                        .process().message(message -> {
                            log.info("message:{}", message.getHeader("dddd"));
                            ArrayList<HashMap<String, Object>>  body = message.getBody(ArrayList.class);
                            log.info("body::::{}",body.toString());
                        })
                        .process(exchange -> {
                            Message in = exchange.getIn();
                            ArrayList<HashMap<String, Object>> aRow = in.getBody(ArrayList.class);
                            log.info("The data count3333:{}", aRow.toString());
                        })
                        //create "insert sql" with parameters
                        .setBody(simple("insert into dgns_gtbaseparam(wellname,recivetime,sgt) values('${body[well_id]}','${body[prod_date]}' :: timestamp,'${body[sgt]}')"))
                        //now for test
                        //.setBody(simple("insert into dgns_gtbaseparam(wellname,recivetime,sgt) values('${body[well_id]}',now(),'${body[sgt]}')"))
                        //look up the insert sql
                        .process().message(message -> {
                    log.info("The insert sql {}", message.getBody(String.class));
                })
                        //try test
                        .doTry()
                        .to("jdbc:diagnosis").log("insert completed")

                        .doCatch(Throwable.class)
                        .log("primary key already exited,insert failed")
                        //"if" statement test
                        *//*.choice()
                            .when(exchange -> {
                                return exchange.getException() != null;
                                if (exchange.getException() != null) {
                                log.error(exchange.getException().getMessage());
                                return exchange.getException().getMessage().contains("already");
                            }
                            return false;
                        }).log("primary key already exited,insert failed")
                        .otherwise().log("insert completed")*//*
                    .endChoice()
                        .end();

            }

            ;


        };
    }*/

    /*@Bean
    public RouteBuilder routeBuilderWithOracle() {
        ArrayList<HashMap<String, Object>> hashMaps = new ArrayList<>();
        return new RouteBuilder() {
            @Override
            public void configure() throws Exception {

            };
        };
    }*/
}
